;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_match
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_misc #"misc.scm")
    (__caml_location #"location.scm")
    (__camli_location #"location.sci")
    (__caml_lambda #"lambda.scm")
    (__caml_instruct #"instruct.scm")
    (__caml_prim #"prim.scm")
    (__caml_syntax #"syntax.scm")
    (__caml_globals #"globals.scm")
    (__caml_const #"const.scm"))
  (export
    (make_path_74@match x1)
    (2-119-make_path_74@match x1 x2)
    (add_to_match_79@match x1)
    (2-20-add_to_match_79@match x1 x2)
    (make_constant_match_131@match x1)
    (2-25-make_constant_match_131@match x1 x2)
    (make_tuple_match_146@match x1)
    (2-237-make_tuple_match_146@match x1 x2)
    (make_construct_match_34@match x1)
    (3-150-make_construct_match_34@match x1 x2 x3)
    (add_to_division_30@match x1)
    (4-90-add_to_division_30@match x1 x2 x3 x4)
    (simpl_casel_240@match x1)
    (divide_constant_matching_24@match x1)
    (divide_tuple_matching_163@match x1)
    (2-66-divide_tuple_matching_163@match x1 x2)
    (divide_construct_matching_84@match x1)
    (divide_var_matching_6@match x1)
    (divide_record_matching_66@match x1)
    (length_of_matching_177@match x1)
    upper_left_pattern_18@match
    (get_span_of_constr_170@match x1)
    (get_span_of_matching_253@match x1)
    (tristate_or_136@match x1)
    conquer_matching_248@match
    (make_initial_matching_65@match x1)
    (translate_matching_84@match x1)
    (3-10-translate_matching_84@match x1 x2 x3)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(begin
  (define make_path_74@match
    (lambda (x1)
      (lambda (x2) (2-119-make_path_74@match x1 x2))))
 (define 2-119-make_path_74@match
    (lambda (x1 x2)
      (labels
        ((staticfail1000
           ()
           (raise (caml-make-extensible
                    'match_failure_1@builtin
                    3
                    #"match.ml"
                    739
                    869))))
        (if (null? x2)
          (staticfail1000)
          (letrec ((x3 (lambda (x4)
                         (if (>=fx x4 x1)
                           (cdr x2)
                           (cons (caml-make-regular
                                   (caml-make-tag 6 19)
                                   2
                                   (caml-make-regular (caml-make-tag 8 38) 1 x4)
                                   (cons (car x2) '()))
                                 (x3 (+fx x4 1)))))))
            (x3 0))))))
)
(begin
  (begin
    (define add_to_match_79@match
      (lambda (x1)
        (lambda (x2) (2-20-add_to_match_79@match x1 x2))))
   (define 2-20-add_to_match_79@match
      (lambda (x1 x2)
        (caml-make-regular
          (caml-make-tag 0 1)
          2
          (cons x2 (caml-constr-get-field x1 0))
          (caml-constr-get-field x1 1))))
)(begin
    (begin
      (define make_constant_match_131@match
        (lambda (x1)
          (lambda (x2)
            (2-25-make_constant_match_131@match x1 x2))))
     (define 2-25-make_constant_match_131@match
        (lambda (x1 x2)
          (labels
            ((staticfail1001
               ()
               (fatal_error_193@misc #"make_constant_match")))
            (if (null? x1)
              (staticfail1001)
              (caml-make-regular
                (caml-make-tag 0 1)
                2
                (cons x2 '())
                (cdr x1))))))
)  (begin
      (begin
        (define make_tuple_match_146@match
          (lambda (x1)
            (lambda (x2)
              (2-237-make_tuple_match_146@match x1 x2))))
       (define 2-237-make_tuple_match_146@match
          (lambda (x1 x2)
            (caml-make-regular
              (caml-make-tag 0 1)
              2
              '()
              ((make_path_74@match x1) x2))))
)    (begin
        (define make_construct_match_34@match
          (lambda (x1)
            (lambda (x2)
              (lambda (x3)
                (3-150-make_construct_match_34@match x1 x2 x3)))))
       (define 3-150-make_construct_match_34@match
          (lambda (x1 x2 x3)
            (labels
              ((staticfail1002
                 ()
                 (raise (caml-make-extensible
                          'match_failure_1@builtin
                          3
                          #"match.ml"
                          1158
                          1421))))
              (if (null? x2)
                (staticfail1002)
                (let ((x4 (caml-constr-get-field
                            (caml-constr-get-field x1 1)
                            4)))
                  (labels
                    ((staticfail1003
                       ()
                       (caml-make-regular
                         (caml-make-tag 0 1)
                         2
                         (cons x3 '())
                         (cons (caml-make-regular
                                 (caml-make-tag 6 19)
                                 2
                                 (caml-make-regular (caml-make-tag 8 38) 1 0)
                                 (cons (car x2) '()))
                               (cdr x2)))))
                    (let ((:-d.1004 x4))
                      (cond ((eq? :-d.1004 (caml-make-tag 0 3))
                             (caml-make-regular
                               (caml-make-tag 0 1)
                               2
                               (cons x3 '())
                               (cdr x2)))
                            (else
                             (case (if (caml-constant-constr? :-d.1004)
                                     -1
                                     (caml-regular-constr-tag :-d.1004))
                               ((3)
                                (caml-make-regular
                                  (caml-make-tag 0 1)
                                  2
                                  (cons x3 '())
                                  x2))
                               (else (staticfail1003))))))))))))
))))
(begin
  (define add_to_division_30@match
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (lambda (x4)
            (4-90-add_to_division_30@match x1 x2 x3 x4))))))
 (define 4-90-add_to_division_30@match
    (lambda (x1 x2 x3 x4)
      (let* ((handler-top1006 current_handler)
             (:-d.1007 (unspecified)))
        (labels
          ((try1008
             (:-d.1007)
             (begin
               (get-the-continuation :-d.1007)
               (if (eq? #t #f) (try1008 (try1008 (try1008 1))))
               (if :-d.1007
                 (let ((x5 ((assoc_252@list x3) x2)))
                   (begin
                     (cell-set!
                       x5
                       ((add_to_match_79@match (cell-ref x5)) x4))
                     x2))
                 current_handler))))
          (let ((x5 (try1008 :-d.1007)))
            (set! current_handler handler-top1006)
            (if (=fx *try* 1)
              (begin
                (set! *try* 0)
                (labels
                  ((staticfail1009 () (raise x5)))
                  (case (caml-extensible-constr-tag x5)
                    ((not_found_4@exc)
                     (cons (caml-make-regular
                             (caml-make-tag 0 1)
                             2
                             x3
                             (make-cell (x1 x4)))
                           x2))
                    (else (staticfail1009)))))
              x5))))))
)
(define simpl_casel_240@match
  (lambda (x1)
    (labels
      ((staticfail1010 () x1))
      (if (null? x1)
        (staticfail1010)
        (if (null? (caml-constr-get-field (car x1) 0))
          (staticfail1010)
          (case (if (caml-constant-constr?
                      (caml-constr-get-field
                        (car (caml-constr-get-field (car x1) 0))
                        0))
                  -1
                  (caml-regular-constr-tag
                    (caml-constr-get-field
                      (car (caml-constr-get-field (car x1) 0))
                      0)))
            ((9 3)
             (simpl_casel_240@match
               (cons (caml-make-regular
                       (caml-make-tag 0 1)
                       2
                       (cons (caml-constr-get-field
                               (caml-constr-get-field
                                 (car (caml-constr-get-field (car x1) 0))
                                 0)
                               0)
                             (cdr (caml-constr-get-field (car x1) 0)))
                       (caml-constr-get-field (car x1) 1))
                     (cdr x1))))
            ((8)
             (simpl_casel_240@match
               (cons (caml-make-regular
                       (caml-make-tag 0 1)
                       2
                       (cons (caml-constr-get-field
                               (caml-constr-get-field
                                 (car (caml-constr-get-field (car x1) 0))
                                 0)
                               0)
                             (cdr (caml-constr-get-field (car x1) 0)))
                       (caml-constr-get-field (car x1) 1))
                     (cons (caml-make-regular
                             (caml-make-tag 0 1)
                             2
                             (cons (caml-constr-get-field
                                     (caml-constr-get-field
                                       (car (caml-constr-get-field (car x1) 0))
                                       0)
                                     1)
                                   (cdr (caml-constr-get-field (car x1) 0)))
                             (caml-constr-get-field (car x1) 1))
                           (cdr x1)))))
            (else (staticfail1010))))))))

(define divide_constant_matching_24@match
  (lambda (x1)
    (letrec ((x2 (lambda (x3)
                   (let ((x4 (simpl_casel_240@match x3)))
                     (labels
                       ((staticfail1011
                          ()
                          (caml-make-regular
                            (caml-make-tag 0 1)
                            2
                            '()
                            (caml-make-regular
                              (caml-make-tag 0 1)
                              2
                              x4
                              (caml-constr-get-field x1 1)))))
                       (if (null? x4)
                         (staticfail1011)
                         (if (null? (caml-constr-get-field (car x4) 0))
                           (staticfail1011)
                           (case (if (caml-constant-constr?
                                       (caml-constr-get-field
                                         (car (caml-constr-get-field
                                                (car x4)
                                                0))
                                         0))
                                   -1
                                   (caml-regular-constr-tag
                                     (caml-constr-get-field
                                       (car (caml-constr-get-field (car x4) 0))
                                       0)))
                             ((4)
                              (let ((x5 (x2 (cdr x4))))
                                (caml-make-regular
                                  (caml-make-tag 0 1)
                                  2
                                  ((((add_to_division_30@match
                                       (make_constant_match_131@match
                                         (caml-constr-get-field x1 1)))
                                     (caml-constr-get-field x5 0))
                                    (caml-constr-get-field
                                      (caml-constr-get-field
                                        (car (caml-constr-get-field (car x4) 0))
                                        0)
                                      0))
                                   (caml-make-regular
                                     (caml-make-tag 0 1)
                                     2
                                     (cdr (caml-constr-get-field (car x4) 0))
                                     (caml-constr-get-field (car x4) 1)))
                                  (caml-constr-get-field x5 1))))
                             (else (staticfail1011))))))))))
      (x2 (caml-constr-get-field x1 0)))))

(begin
  (define divide_tuple_matching_163@match
    (lambda (x1)
      (lambda (x2)
        (2-66-divide_tuple_matching_163@match x1 x2))))
 (define 2-66-divide_tuple_matching_163@match
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (let ((x5 (simpl_casel_240@match x4)))
                       (labels
                         ((staticfail1012
                            ()
                            (fatal_error_193@misc #"divide_tuple_matching")))
                         (if (null? x5)
                           ((make_tuple_match_146@match x1)
                            (caml-constr-get-field x2 1))
                           (if (null? (caml-constr-get-field (car x5) 0))
                             (staticfail1012)
                             (let ((:-d.1013
                                     (caml-constr-get-field
                                       (car (caml-constr-get-field (car x5) 0))
                                       0)))
                               (cond ((eq? :-d.1013 (caml-make-tag 0 10))
                                      (letrec ((x6 (lambda (x7)
                                                     (if (>=fx x7 x1)
                                                       '()
                                                       (cons (caml-make-regular
                                                               (caml-make-tag
                                                                 0
                                                                 1)
                                                               2
                                                               (caml-make-tag
                                                                 0
                                                                 10)
                                                               no_location_97@location)
                                                             (x6 (+fx x7
                                                                      1)))))))
                                        ((add_to_match_79@match (x3 (cdr x5)))
                                         (caml-make-regular
                                           (caml-make-tag 0 1)
                                           2
                                           ((@_176@list (x6 0))
                                            (cdr (caml-constr-get-field
                                                   (car x5)
                                                   0)))
                                           (caml-constr-get-field
                                             (car x5)
                                             1)))))
                                     (else
                                      (case (if (caml-constant-constr? :-d.1013)
                                              -1
                                              (caml-regular-constr-tag
                                                :-d.1013))
                                        ((5)
                                         ((add_to_match_79@match (x3 (cdr x5)))
                                          (caml-make-regular
                                            (caml-make-tag 0 1)
                                            2
                                            ((@_176@list
                                               (caml-constr-get-field
                                                 (caml-constr-get-field
                                                   (car (caml-constr-get-field
                                                          (car x5)
                                                          0))
                                                   0)
                                                 0))
                                             (cdr (caml-constr-get-field
                                                    (car x5)
                                                    0)))
                                            (caml-constr-get-field
                                              (car x5)
                                              1))))
                                        ((2)
                                         (letrec ((x6 (lambda (x7)
                                                        (if (>=fx x7 x1)
                                                          '()
                                                          (cons (caml-make-regular
                                                                  (caml-make-tag
                                                                    0
                                                                    1)
                                                                  2
                                                                  (caml-make-tag
                                                                    0
                                                                    10)
                                                                  no_location_97@location)
                                                                (x6 (+fx x7
                                                                         1)))))))
                                           ((add_to_match_79@match
                                              (x3 (cdr x5)))
                                            (caml-make-regular
                                              (caml-make-tag 0 1)
                                              2
                                              ((@_176@list (x6 0))
                                               (cdr (caml-constr-get-field
                                                      (car x5)
                                                      0)))
                                              (caml-constr-get-field
                                                (car x5)
                                                1)))))
                                        (else (staticfail1012)))))))))))))
        (x3 (caml-constr-get-field x2 0)))))
)
(define divide_construct_matching_84@match
  (lambda (x1)
    (letrec ((x2 (lambda (x3)
                   (let ((x4 (simpl_casel_240@match x3)))
                     (labels
                       ((staticfail1014
                          ()
                          (caml-make-regular
                            (caml-make-tag 0 1)
                            2
                            '()
                            (caml-make-regular
                              (caml-make-tag 0 1)
                              2
                              x4
                              (caml-constr-get-field x1 1)))))
                       (if (null? x4)
                         (staticfail1014)
                         (if (null? (caml-constr-get-field (car x4) 0))
                           (staticfail1014)
                           (case (if (caml-constant-constr?
                                       (caml-constr-get-field
                                         (car (caml-constr-get-field
                                                (car x4)
                                                0))
                                         0))
                                   -1
                                   (caml-regular-constr-tag
                                     (caml-constr-get-field
                                       (car (caml-constr-get-field (car x4) 0))
                                       0)))
                             ((6)
                              (let ((x5 (x2 (cdr x4))))
                                (caml-make-regular
                                  (caml-make-tag 0 1)
                                  2
                                  ((((add_to_division_30@match
                                       ((make_construct_match_34@match
                                          (caml-constr-get-field
                                            (caml-constr-get-field
                                              (car (caml-constr-get-field
                                                     (car x4)
                                                     0))
                                              0)
                                            0))
                                        (caml-constr-get-field x1 1)))
                                     (caml-constr-get-field x5 0))
                                    (caml-constr-get-field
                                      (caml-constr-get-field
                                        (car (caml-constr-get-field (car x4) 0))
                                        0)
                                      0))
                                   (caml-make-regular
                                     (caml-make-tag 0 1)
                                     2
                                     (cdr (caml-constr-get-field (car x4) 0))
                                     (caml-constr-get-field (car x4) 1)))
                                  (caml-constr-get-field x5 1))))
                             ((7)
                              (let ((x5 (let ((x5 (caml-constr-get-field
                                                    (caml-constr-get-field
                                                      (caml-constr-get-field
                                                        (caml-constr-get-field
                                                          (car (caml-constr-get-field
                                                                 (car x4)
                                                                 0))
                                                          0)
                                                        0)
                                                      1)
                                                    4)))
                                          (labels
                                            ((staticfail1015
                                               ()
                                               (cons (caml-constr-get-field
                                                       (caml-constr-get-field
                                                         (car (caml-constr-get-field
                                                                (car x4)
                                                                0))
                                                         0)
                                                       1)
                                                     (cdr (caml-constr-get-field
                                                            (car x4)
                                                            0)))))
                                            (let ((:-d.1016 x5))
                                              (cond ((eq? :-d.1016
                                                          (caml-make-tag 0 3))
                                                     (cdr (caml-constr-get-field
                                                            (car x4)
                                                            0)))
                                                    (else
                                                     (staticfail1015))))))))
                                (let ((x6 (x2 (cdr x4))))
                                  (caml-make-regular
                                    (caml-make-tag 0 1)
                                    2
                                    ((((add_to_division_30@match
                                         ((make_construct_match_34@match
                                            (caml-constr-get-field
                                              (caml-constr-get-field
                                                (car (caml-constr-get-field
                                                       (car x4)
                                                       0))
                                                0)
                                              0))
                                          (caml-constr-get-field x1 1)))
                                       (caml-constr-get-field x6 0))
                                      (caml-constr-get-field
                                        (caml-constr-get-field
                                          (car (caml-constr-get-field
                                                 (car x4)
                                                 0))
                                          0)
                                        0))
                                     (caml-make-regular
                                       (caml-make-tag 0 1)
                                       2
                                       x5
                                       (caml-constr-get-field (car x4) 1)))
                                    (caml-constr-get-field x6 1)))))
                             (else (staticfail1014))))))))))
      (x2 (caml-constr-get-field x1 0)))))

(define divide_var_matching_6@match
  (lambda (x1)
    (labels
      ((staticfail1017
         ()
         (raise (caml-make-extensible
                  'match_failure_1@builtin
                  3
                  #"match.ml"
                  4055
                  4443))))
      (if (null? (caml-constr-get-field x1 1))
        (staticfail1017)
        (letrec ((x2 (lambda (x3)
                       (let ((x4 (simpl_casel_240@match x3)))
                         (labels
                           ((staticfail1018
                              ()
                              (caml-make-regular
                                (caml-make-tag 0 1)
                                2
                                (caml-make-regular
                                  (caml-make-tag 0 1)
                                  2
                                  '()
                                  (cdr (caml-constr-get-field x1 1)))
                                (caml-make-regular
                                  (caml-make-tag 0 1)
                                  2
                                  x4
                                  (caml-constr-get-field x1 1)))))
                           (if (null? x4)
                             (staticfail1018)
                             (if (null? (caml-constr-get-field (car x4) 0))
                               (staticfail1018)
                               (let ((:-d.1019
                                       (caml-constr-get-field
                                         (car (caml-constr-get-field
                                                (car x4)
                                                0))
                                         0)))
                                 (cond ((eq? :-d.1019 (caml-make-tag 0 10))
                                        (let ((x5 (x2 (cdr x4))))
                                          (caml-make-regular
                                            (caml-make-tag 0 1)
                                            2
                                            ((add_to_match_79@match
                                               (caml-constr-get-field x5 0))
                                             (caml-make-regular
                                               (caml-make-tag 0 1)
                                               2
                                               (cdr (caml-constr-get-field
                                                      (car x4)
                                                      0))
                                               (caml-constr-get-field
                                                 (car x4)
                                                 1)))
                                            (caml-constr-get-field x5 1))))
                                       (else
                                        (case (if (caml-constant-constr?
                                                    :-d.1019)
                                                -1
                                                (caml-regular-constr-tag
                                                  :-d.1019))
                                          ((2)
                                           (let ((x5 (x2 (cdr x4))))
                                             (caml-make-regular
                                               (caml-make-tag 0 1)
                                               2
                                               ((add_to_match_79@match
                                                  (caml-constr-get-field x5 0))
                                                (caml-make-regular
                                                  (caml-make-tag 0 1)
                                                  2
                                                  (cdr (caml-constr-get-field
                                                         (car x4)
                                                         0))
                                                  (caml-constr-get-field
                                                    (car x4)
                                                    1)))
                                               (caml-constr-get-field x5 1))))
                                          (else (staticfail1018)))))))))))))
          (x2 (caml-constr-get-field x1 0)))))))

(define divide_record_matching_66@match
  (lambda (x1)
    (let ((x2 0))
      (letrec ((x3 (lambda (x4)
                     (labels
                       ((staticfail1023 () (caml-make-tag 0 1)))
                       (case (if (caml-constant-constr?
                                   (caml-constr-get-field x4 0))
                               -1
                               (caml-regular-constr-tag
                                 (caml-constr-get-field x4 0)))
                         ((9 3)
                          (x3 (caml-constr-get-field
                                (caml-constr-get-field x4 0)
                                0)))
                         ((8)
                          (begin
                            (x3 (caml-constr-get-field
                                  (caml-constr-get-field x4 0)
                                  0))
                            (x3 (caml-constr-get-field
                                  (caml-constr-get-field x4 0)
                                  1))))
                         ((10)
                          ((do_list_18@list
                             (lambda (x5)
                               (if (>fx (caml-constr-get-field
                                          (caml-constr-get-field
                                            (caml-constr-get-field x5 0)
                                            1)
                                          3)
                                        x2)
                                 (begin
                                   (set! x2
                                     (caml-constr-get-field
                                       (caml-constr-get-field
                                         (caml-constr-get-field x5 0)
                                         1)
                                       3))
                                   (caml-make-tag 0 1))
                                 (caml-make-tag 0 1))))
                           (caml-constr-get-field
                             (caml-constr-get-field x4 0)
                             0)))
                         (else (staticfail1023)))))))
        (begin
          ((do_list_18@list
             (lambda (x4)
               (labels
                 ((staticfail1020
                    ()
                    (fatal_error_193@misc #"divide_record_matching")))
                 (if (null? (caml-constr-get-field x4 0))
                   (staticfail1020)
                   (x3 (car (caml-constr-get-field x4 0)))))))
           (caml-constr-get-field x1 0))
          (letrec ((x4 (lambda (x6)
                         (labels
                           ((staticfail1021
                              ()
                              (fatal_error_193@misc #"divide_record_matching")))
                           (if (null? x6)
                             (caml-make-regular
                               (caml-make-tag 0 1)
                               2
                               '()
                               ((make_path_74@match (+fx x2 1))
                                (caml-constr-get-field x1 1)))
                             (if (null? (caml-constr-get-field (car x6) 0))
                               (staticfail1021)
                               (let ((:-d.1022
                                       (caml-constr-get-field
                                         (car (caml-constr-get-field
                                                (car x6)
                                                0))
                                         0)))
                                 (cond ((eq? :-d.1022 (caml-make-tag 0 10))
                                        ((((x5 '())
                                           (cdr (caml-constr-get-field
                                                  (car x6)
                                                  0)))
                                          (caml-constr-get-field (car x6) 1))
                                         (cdr x6)))
                                       (else
                                        (case (if (caml-constant-constr?
                                                    :-d.1022)
                                                -1
                                                (caml-regular-constr-tag
                                                  :-d.1022))
                                          ((9 3)
                                           (x4 (cons (caml-make-regular
                                                       (caml-make-tag 0 1)
                                                       2
                                                       (cons (caml-constr-get-field
                                                               (caml-constr-get-field
                                                                 (car (caml-constr-get-field
                                                                        (car x6)
                                                                        0))
                                                                 0)
                                                               0)
                                                             (cdr (caml-constr-get-field
                                                                    (car x6)
                                                                    0)))
                                                       (caml-constr-get-field
                                                         (car x6)
                                                         1))
                                                     (cdr x6))))
                                          ((8)
                                           (x4 (cons (caml-make-regular
                                                       (caml-make-tag 0 1)
                                                       2
                                                       (cons (caml-constr-get-field
                                                               (caml-constr-get-field
                                                                 (car (caml-constr-get-field
                                                                        (car x6)
                                                                        0))
                                                                 0)
                                                               0)
                                                             (cdr (caml-constr-get-field
                                                                    (car x6)
                                                                    0)))
                                                       (caml-constr-get-field
                                                         (car x6)
                                                         1))
                                                     (cons (caml-make-regular
                                                             (caml-make-tag 0 1)
                                                             2
                                                             (cons (caml-constr-get-field
                                                                     (caml-constr-get-field
                                                                       (car (caml-constr-get-field
                                                                              (car x6)
                                                                              0))
                                                                       0)
                                                                     1)
                                                                   (cdr (caml-constr-get-field
                                                                          (car x6)
                                                                          0)))
                                                             (caml-constr-get-field
                                                               (car x6)
                                                               1))
                                                           (cdr x6)))))
                                          ((10)
                                           ((((x5 (caml-constr-get-field
                                                    (caml-constr-get-field
                                                      (car (caml-constr-get-field
                                                             (car x6)
                                                             0))
                                                      0)
                                                    0))
                                              (cdr (caml-constr-get-field
                                                     (car x6)
                                                     0)))
                                             (caml-constr-get-field (car x6) 1))
                                            (cdr x6)))
                                          ((2)
                                           ((((x5 '())
                                              (cdr (caml-constr-get-field
                                                     (car x6)
                                                     0)))
                                             (caml-constr-get-field (car x6) 1))
                                            (cdr x6)))
                                          (else (staticfail1021)))))))))))
                   (x5 (lambda (x6)
                         (lambda (x7)
                           (lambda (x8)
                             (lambda (x9)
                               (let ((x10 (make-vector
                                            (+fx x2 1)
                                            (caml-make-regular
                                              (caml-make-tag 0 1)
                                              2
                                              (caml-make-tag 0 10)
                                              no_location_97@location))))
                                 (begin
                                   ((do_list_18@list
                                      (lambda (x11)
                                        (vector-set!
                                          x10
                                          (caml-constr-get-field
                                            (caml-constr-get-field
                                              (caml-constr-get-field x11 0)
                                              1)
                                            3)
                                          (caml-constr-get-field x11 1))))
                                    x6)
                                   ((add_to_match_79@match (x4 x9))
                                    (caml-make-regular
                                      (caml-make-tag 0 1)
                                      2
                                      ((@_176@list (list_of_vect_3@fvect x10))
                                       x7)
                                      x8))))))))))
            (x4 (caml-constr-get-field x1 0))))))))

(define length_of_matching_177@match
  (lambda (x1)
    (list_length_112@list
      (caml-constr-get-field x1 0))))

(define upper_left_pattern_18@match
  (letrec ((x1 (lambda (x2)
                 (labels
                   ((staticfail1025 () x2))
                   (case (if (caml-constant-constr?
                               (caml-constr-get-field x2 0))
                           -1
                           (caml-regular-constr-tag
                             (caml-constr-get-field x2 0)))
                     ((8 9 3)
                      (x1 (caml-constr-get-field
                            (caml-constr-get-field x2 0)
                            0)))
                     (else (staticfail1025)))))))
    (lambda (x2)
      (labels
        ((staticfail1024
           ()
           (fatal_error_193@misc #"upper_left_pattern")))
        (if (null? (caml-constr-get-field x2 0))
          (staticfail1024)
          (if (null? (caml-constr-get-field
                       (car (caml-constr-get-field x2 0))
                       0))
            (staticfail1024)
            (x1 (car (caml-constr-get-field
                       (car (caml-constr-get-field x2 0))
                       0)))))))))

(define get_span_of_constr_170@match
  (lambda (x1)
    (let ((x2 (caml-constr-get-field
                (caml-constr-get-field x1 1)
                3)))
      (case (caml-regular-constr-tag x2)
        ((1) 0)
        (else (caml-constr-get-field x2 2))))))

(define get_span_of_matching_253@match
  (lambda (x1)
    (let ((x2 (upper_left_pattern_18@match x1)))
      (labels
        ((staticfail1026
           ()
           (fatal_error_193@misc #"get_span_of_matching")))
        (case (if (caml-constant-constr?
                    (caml-constr-get-field x2 0))
                -1
                (caml-regular-constr-tag
                  (caml-constr-get-field x2 0)))
          ((7 6)
           (get_span_of_constr_170@match
             (caml-constr-get-field
               (caml-constr-get-field x2 0)
               0)))
          (else (staticfail1026)))))))

(define tristate_or_136@match
  (lambda (x1)
    (labels
      ((staticfail1027
         ()
         (labels
           ((staticfail1028
              ()
              (labels
                ((staticfail1029 () (caml-make-tag 1 3)))
                (let ((:-d.1030 (caml-constr-get-field x1 0)))
                  (cond ((eq? :-d.1030 (caml-make-tag 0 3))
                         (let ((:-d.1031 (caml-constr-get-field x1 1)))
                           (cond ((eq? :-d.1031 (caml-make-tag 0 3))
                                  (caml-make-tag 0 3))
                                 (else (staticfail1029)))))
                        (else (staticfail1029)))))))
           (let ((:-d.1032 (caml-constr-get-field x1 1)))
             (cond ((eq? :-d.1032 (caml-make-tag 2 3))
                    (caml-make-tag 2 3))
                   (else (staticfail1028)))))))
      (let ((:-d.1033 (caml-constr-get-field x1 0)))
        (cond ((eq? :-d.1033 (caml-make-tag 2 3))
               (caml-make-tag 2 3))
              (else (staticfail1027)))))))

(begin
  (define conquer_matching_248@match (unspecified))
  (set! conquer_matching_248@match
    (letrec ((x1 (lambda (x2)
                   (if (null? x2)
                     (caml-make-regular
                       (caml-make-tag 0 1)
                       3
                       '()
                       (caml-make-tag 0 3)
                       '())
                     (let ((x3 (conquer_matching_248@match
                                 (cell-ref (caml-constr-get-field (car x2) 1))))
                           (x4 (x1 (cdr x2))))
                       (caml-make-regular
                         (caml-make-tag 0 1)
                         3
                         (cons (caml-make-regular
                                 (caml-make-tag 0 1)
                                 2
                                 (caml-constr-get-field (car x2) 0)
                                 (caml-constr-get-field x3 0))
                               (caml-constr-get-field x4 0))
                         (tristate_or_136@match
                           (caml-make-regular
                             (caml-make-tag 0 1)
                             2
                             (caml-constr-get-field x3 1)
                             (caml-constr-get-field x4 1)))
                         ((@_176@list (caml-constr-get-field x3 2))
                          (caml-constr-get-field x4 2))))))))
      (lambda (x2)
        (labels
          ((staticfail1034
             ()
             (fatal_error_193@misc #"conquer_matching 1")))
          (labels
            ((staticfail1035
               ()
               (if (null? (caml-constr-get-field x2 1))
                 (staticfail1034)
                 (let ((x3 (upper_left_pattern_18@match x2)))
                   (labels
                     ((staticfail1036
                        ()
                        (fatal_error_193@misc #"conquer_matching 2")))
                     (let ((:-d.1037 (caml-constr-get-field x3 0)))
                       (cond ((eq? :-d.1037 (caml-make-tag 0 10))
                              (let ((x4 (divide_var_matching_6@match x2)))
                                (let ((x5 (conquer_matching_248@match
                                            (caml-constr-get-field x4 0)))
                                      (x6 (conquer_matching_248@match
                                            (caml-constr-get-field x4 1))))
                                  (if (eq? (caml-constr-get-field x5 1)
                                           (caml-make-tag 0 3))
                                    (caml-make-regular
                                      (caml-make-tag 0 1)
                                      3
                                      (caml-constr-get-field x5 0)
                                      (caml-make-tag 0 3)
                                      (caml-constr-get-field x5 2))
                                    (caml-make-regular
                                      (caml-make-tag 0 1)
                                      3
                                      (caml-make-regular
                                        (caml-make-tag 10 19)
                                        2
                                        (caml-constr-get-field x5 0)
                                        (caml-constr-get-field x6 0))
                                      (if (eq? (caml-constr-get-field x6 1)
                                               (caml-make-tag 0 3))
                                        (caml-make-tag 0 3)
                                        (caml-make-tag 1 3))
                                      ((@_176@list (caml-constr-get-field x5 2))
                                       (caml-constr-get-field x6 2)))))))
                             (else
                              (case (if (caml-constant-constr? :-d.1037)
                                      -1
                                      (caml-regular-constr-tag :-d.1037))
                                ((2)
                                 (let ((x4 (divide_var_matching_6@match x2)))
                                   (let ((x5 (conquer_matching_248@match
                                               (caml-constr-get-field x4 0)))
                                         (x6 (conquer_matching_248@match
                                               (caml-constr-get-field x4 1))))
                                     (if (eq? (caml-constr-get-field x5 1)
                                              (caml-make-tag 0 3))
                                       (caml-make-regular
                                         (caml-make-tag 0 1)
                                         3
                                         (caml-constr-get-field x5 0)
                                         (caml-make-tag 0 3)
                                         (caml-constr-get-field x5 2))
                                       (caml-make-regular
                                         (caml-make-tag 0 1)
                                         3
                                         (caml-make-regular
                                           (caml-make-tag 10 19)
                                           2
                                           (caml-constr-get-field x5 0)
                                           (caml-constr-get-field x6 0))
                                         (if (eq? (caml-constr-get-field x6 1)
                                                  (caml-make-tag 0 3))
                                           (caml-make-tag 0 3)
                                           (caml-make-tag 1 3))
                                         ((@_176@list
                                            (caml-constr-get-field x5 2))
                                          (caml-constr-get-field x6 2)))))))
                                ((5)
                                 (conquer_matching_248@match
                                   ((divide_tuple_matching_163@match
                                      (list_length_112@list
                                        (caml-constr-get-field
                                          (caml-constr-get-field x3 0)
                                          0)))
                                    x2)))
                                ((7 6)
                                 (let ((x4 (divide_construct_matching_84@match
                                             x2)))
                                   (let ((x5 (x1 (caml-constr-get-field x4 0)))
                                         (x6 (conquer_matching_248@match
                                               (caml-constr-get-field x4 1))))
                                     (let ((x7 (get_span_of_matching_253@match
                                                 x2))
                                           (x8 (list_length_112@list
                                                 (caml-constr-get-field x4 0))))
                                       (if (and (eq? x8 x7)
                                                (eq? (caml-constr-get-field
                                                       x5
                                                       1)
                                                     (caml-make-tag 0 3)))
                                         (caml-make-regular
                                           (caml-make-tag 0 1)
                                           3
                                           (caml-make-regular
                                             (caml-make-tag 8 19)
                                             3
                                             x7
                                             (car (caml-constr-get-field x2 1))
                                             (caml-constr-get-field x5 0))
                                           (caml-make-tag 0 3)
                                           (caml-constr-get-field x5 2))
                                         (caml-make-regular
                                           (caml-make-tag 0 1)
                                           3
                                           (caml-make-regular
                                             (caml-make-tag 10 19)
                                             2
                                             (caml-make-regular
                                               (caml-make-tag 8 19)
                                               3
                                               x7
                                               (car (caml-constr-get-field
                                                      x2
                                                      1))
                                               (caml-constr-get-field x5 0))
                                             (caml-constr-get-field x6 0))
                                           (if (eq? (caml-constr-get-field x6 1)
                                                    (caml-make-tag 0 3))
                                             (caml-make-tag 0 3)
                                             (if (and (<fx x8 x7)
                                                      (eq? (caml-constr-get-field
                                                             x6
                                                             1)
                                                           (caml-make-tag 2 3)))
                                               (caml-make-tag 2 3)
                                               (caml-make-tag 1 3)))
                                           ((@_176@list
                                              (caml-constr-get-field x5 2))
                                            (caml-constr-get-field x6 2))))))))
                                ((4)
                                 (let ((x4 (divide_constant_matching_24@match
                                             x2)))
                                   (let ((x5 (x1 (caml-constr-get-field x4 0)))
                                         (x6 (conquer_matching_248@match
                                               (caml-constr-get-field x4 1))))
                                     (caml-make-regular
                                       (caml-make-tag 0 1)
                                       3
                                       (caml-make-regular
                                         (caml-make-tag 10 19)
                                         2
                                         (caml-make-regular
                                           (caml-make-tag 7 19)
                                           2
                                           (car (caml-constr-get-field x2 1))
                                           (caml-constr-get-field x5 0))
                                         (caml-constr-get-field x6 0))
                                       (caml-constr-get-field x6 1)
                                       ((@_176@list
                                          (caml-constr-get-field x5 2))
                                        (caml-constr-get-field x6 2))))))
                                ((10)
                                 (conquer_matching_248@match
                                   (divide_record_matching_66@match x2)))
                                (else (staticfail1036)))))))))))
            (if (null? (caml-constr-get-field x2 0))
              (caml-make-regular
                (caml-make-tag 0 1)
                3
                (caml-make-tag 9 19)
                (caml-make-tag 2 3)
                '())
              (if (null? (caml-constr-get-field
                           (car (caml-constr-get-field x2 0))
                           0))
                (caml-make-regular
                  (caml-make-tag 0 1)
                  3
                  (caml-constr-get-field
                    (car (caml-constr-get-field x2 0))
                    1)
                  (caml-make-tag 0 3)
                  (cons (caml-constr-get-field
                          (car (caml-constr-get-field x2 0))
                          1)
                        '()))
                (staticfail1035)))))))))
(define make_initial_matching_65@match
  (lambda (x1)
    (if (null? x1)
      (fatal_error_193@misc
        #"make_initial_matching: empty")
      (letrec ((x2 (lambda (x3)
                     (if (<=fx x3 0)
                       '()
                       (cons (caml-make-regular
                               (caml-make-tag 0 19)
                               1
                               (-fx x3 1))
                             (x2 (-fx x3 1)))))))
        (caml-make-regular
          (caml-make-tag 0 1)
          2
          x1
          (x2 (list_length_112@list
                (caml-constr-get-field (car x1) 0))))))))

(begin
  (define translate_matching_84@match
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (3-10-translate_matching_84@match x1 x2 x3)))))
 (define 3-10-translate_matching_84@match
    (lambda (x1 x2 x3)
      (let ((x4 ((map_118@list
                   (lambda (x4)
                     (caml-make-regular
                       (caml-make-tag 0 1)
                       2
                       (caml-constr-get-field x4 0)
                       (share_lambda_40@lambda
                         (caml-constr-get-field x4 1)))))
                 x3)))
        (let ((x5 (conquer_matching_248@match
                    (make_initial_matching_65@match x4))))
          (begin
            (if (not ((for_all_96@list
                        (lambda (x6)
                          ((memq_162@list (caml-constr-get-field x6 1))
                           (caml-constr-get-field x5 2))))
                      x4))
              (begin
                (prerr_location_1@location x2)
                (begin
                  (prerr_begline_213@misc
                    #" Warning: some cases are unused in this matching.")
                  (prerr_endline2_160@misc #"")))
              (caml-make-tag 0 1))
            (let ((x6 (caml-constr-get-field x5 1)))
              (labels
                ((staticfail1038
                   ()
                   (caml-make-regular
                     (caml-make-tag 10 19)
                     2
                     (caml-constr-get-field x5 0)
                     (x1 (caml-constr-get-field x5 1)))))
                (let ((:-d.1039 x6))
                  (cond ((eq? :-d.1039 (caml-make-tag 0 3))
                         (caml-constr-get-field x5 0))
                        (else (staticfail1038)))))))))))
)
